/*
 *  TriMeshOpenGLViewer-Phong
 *  Copyright (C) 2005  Thanassis Tsiodras (ttsiod@softlab.ntua.gr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __CAMERA_H__
#define __CAMERA_H__

#include "Types.h"
#include "Point.h"
#include "Screen3D.h"
#include "Scene.h"

class Triangle;

class Camera: public Point {
    coord _leftangle, _upangle;
    Scene *_scene;
    Screen3D *_screen;
    RenderState _state;
public:
    Camera(
	coord eyex, coord eyey, coord eyez,
	coord leftangle, coord upangle, 
	Scene* scene, 
	Screen3D *screen);

    void setRenderState(RenderState);

    void render();

    void set(coord x, coord y, coord z) { Point::set(x,y,z); }

    void set(
	coord xEye, coord yEye, coord zEye, 
	coord lAng, coord uAng) 
    {
        Point::set(xEye, yEye, zEye);
        _leftangle = lAng; _upangle = uAng;
    }

    Scene *getScene() { return _scene; }

    Screen3D *getScreen() { return _screen; }

    coord getlAng() { return _leftangle; }

    coord getuAng() { return _upangle; }

    void lookGLU();

private:
    void renderPoints();
    void renderLines();
    void renderGouraud();
    void renderPhong();
};

#endif
