/*
 *  TriMeshOpenGLViewer-Phong
 *  Copyright (C) 2005  Thanassis Tsiodras (ttsiod@softlab.ntua.gr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "Keyboard.h"

Keyboard::Keyboard()
{
    _isDown=_isUp=_isLeft=_isRight=_isMode=_isS=_isD=_isE=_isF=_isR=
                                               _isForward=_isBackward=_isLight=_abortFlag=0;
}

Keyboard::~Keyboard()
{
}

void Keyboard::poll()
{
    SDL_Event event;

    if(SDL_PollEvent(&event)) {

        switch(event.type) {
        case SDL_KEYDOWN:
            {
                switch(event.key.keysym.sym) {
                case SDLK_UP: _isUp = 1; break;
                case SDLK_DOWN: _isDown = 1; break;
                case SDLK_LEFT: _isLeft = 1; break;
                case SDLK_RIGHT: _isRight = 1; break;
                case SDLK_a: _isForward = 1; break;
                case SDLK_z: _isBackward = 1; break;
                case SDLK_w: _isLight = 1; break;
                case SDLK_s: _isS = 1; break;
                case SDLK_d: _isD = 1; break;
                case SDLK_f: _isF = 1; break;
                case SDLK_e: _isE = 1; break;
                case SDLK_r: _isR = 1; break;
                case SDLK_ESCAPE: _abortFlag = 1; break;
                case SDLK_SPACE: _isMode = 1; break;
                default: break;
                }
            }
            break;
        case SDL_KEYUP:
            {
                switch(event.key.keysym.sym) {
                case SDLK_UP: _isUp = 0; break;
                case SDLK_DOWN: _isDown = 0; break;
                case SDLK_LEFT: _isLeft = 0; break;
                case SDLK_RIGHT: _isRight = 0; break;
                case SDLK_a: _isForward = 0; break;
                case SDLK_z: _isBackward = 0; break;
                case SDLK_w: _isLight = 0; break;
                case SDLK_s: _isS = 0; break;
                case SDLK_d: _isD = 0; break;
                case SDLK_f: _isF = 0; break;
                case SDLK_e: _isE = 0; break;
                case SDLK_r: _isR = 0; break;
                case SDLK_ESCAPE: _abortFlag = 0; break;
                case SDLK_SPACE: _isMode = 0; break;
                default: break;
                }
            }
            break;
        default:
            break;
        } // switch(event.type)
    } // if (SDL_PollEvent(...))
}
