/*
 *  TriMeshOpenGLViewer-Phong
 *  Copyright (C) 2005  Thanassis Tsiodras (ttsiod@softlab.ntua.gr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __KEYBOARD_H__
#define __KEYBOARD_H__

#include <SDL.h>

class Keyboard {
    Uint32 _isDown, _isUp, _isLeft, _isRight;
    Uint32 _isForward, _isBackward, _isLight;
    Uint32 _abortFlag, _isMode;
    Uint32 _isS, _isD, _isE, _isF, _isR;
public:
    Keyboard();
    ~Keyboard();

    void poll();
    Uint32 Down() { return _isDown; }
    Uint32 Up(){ return _isUp; }
    Uint32 Left() { return _isLeft; }
    Uint32 Right() { return _isRight; }
    Uint32 Forward() { return _isForward; }
    Uint32 Backward() { return _isBackward; }
    Uint32 Light() { return _isLight; }
    Uint32 Mode() { return _isMode; }
    Uint32 Abort() { return _abortFlag; }
    Uint32 isS() { return _isS; }
    Uint32 isD() { return _isD; }
    Uint32 isE() { return _isE; }
    Uint32 isF() { return _isF; }
    Uint32 isR() { return _isR; }
};

#endif
