/*
 *  TriMeshOpenGLViewer-Phong
 *  Copyright (C) 2005  Thanassis Tsiodras (ttsiod@softlab.ntua.gr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __LIGHT_H__
#define __LIGHT_H__

#include "Types.h"
#include "Point.h"
#include "Scene.h"
#include "Camera.h"
#include "Exceptions.h"

class Light : public Point {
    Scene *_scene;
    static int _lights;
    int _lightNo;
public:
    Light(coord x, coord y, coord z)
	:
    	Point(x,y,z)
    {
        _lightNo = _lights++;
        if (_lights == 8) { THROW("Up to 8 lights available"); }
    }

    void setScene(Scene *scene) { _scene = scene; }
    Scene *getScene() { return _scene; }

    void set(coord x, coord y, coord z);

    void SetupLightInOpenGL(Camera& camera);

    void DrawLightUsingBitmapSun(Camera& camera);
};

#endif
