/*
 *  TriMeshOpenGLViewer-Phong
 *  Copyright (C) 2005  Thanassis Tsiodras (ttsiod@softlab.ntua.gr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __POINT_H__
#define __POINT_H__

#include <GL/gl.h>

#include <iostream>

using namespace std;

#include "Types.h"

class Point {
    GLfloat _data[4];
public:
    Point(coord x=0.0, coord y=0.0, coord z=0.0);
    virtual ~Point();

    coord getX() const { return _data[0]; }
    coord getY() const { return _data[1]; }
    coord getZ() const { return _data[2]; }

    GLfloat *getArrayGL() { return &_data[0]; }

    virtual Point& operator+=(const Point& offset);

    void move(const Point& offset);
    void move(coord dx, coord dy, coord dz);

    void set(coord x, coord y, coord z);
    void set(const Point& point);

    void normalize();
};

ostream& operator<<(ostream&, Point&);

#endif
