/*
 *  TriMeshOpenGLViewer-Phong
 *  Copyright (C) 2005  Thanassis Tsiodras (ttsiod@softlab.ntua.gr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __SCENE_H__
#define __SCENE_H__

#include <vector>

class Scene;
class Camera;
class Light;
class Object;

#include "Camera.h"
#include "Light.h"

class Scene {
public:
    std::vector<Camera*> _cameras;
    std::vector<Light*> _lights;
    std::vector<Object*> _objects;
public:
    Scene() {}

    void addLight(Light* light);

    void addCamera(Camera* camera);

    void addObject(Object *object);

    void DrawLights(Camera& camera);

    void renderPoints(Camera&);
    void renderLines(Camera&);
    void renderGouraud(Camera&, bool isWireFrame = false);
    void renderPhong(Camera&);
};

#endif
