/*
 *  TriMeshOpenGLViewer-Phong
 *  Copyright (C) 2005  Thanassis Tsiodras (ttsiod@softlab.ntua.gr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __SCREEN_H__
#define __SCREEN_H__

#include <SDL.h>
#include <GL/gl.h>

#include "Types.h"
#include "Defines.h"

class Camera;
class Point;
class Vertex;
class Triangle;

class Screen3D {
public:
    Screen3D();
    void InitGL();
    void initShader();
    ~Screen3D();

    void setTitle(const char *);
    void showPage();
    void clearPage();

    void plot(Vertex *);
    void drawTriangleGouraud(Triangle *t);
    void drawTrianglePhong(Triangle *t);

    coord getWidth() { return WIDTH; }
    coord getHeight() { return HEIGHT; }

    void loadGLTexture();
    GLuint getFirstTexture() { return _textures[0]; }

private:
    GLuint _textures[7];
};

#endif
