/*
 *  TriMeshOpenGLViewer-Phong
 *  Copyright (C) 2005  Thanassis Tsiodras (ttsiod@softlab.ntua.gr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __VARIABLES_H__
#define __VARIABLES_H__

#ifdef GLOBAL_DEFS
#define DECLAREDEFINEVAR(Type,Var,Value)    Type Var(Value);
#define EXTERN
#else
#define DECLAREDEFINEVAR(Type,Var,Value)    extern Type Var;
#define EXTERN extern
#endif

#include "Types.h"

DECLAREDEFINEVAR(int,g_verbose,0)
DECLAREDEFINEVAR(bool,g_CullingEnabled,true)
DECLAREDEFINEVAR(coord,g_interAngle,80.0)
DECLAREDEFINEVAR(bool,g_PhongEnabled,false)
DECLAREDEFINEVAR(bool,g_VBOEnabled,false)

#ifdef _WIN32
EXTERN GlGenProgramsARB glGenProgramsARB;
EXTERN GlBindProgramARB glBindProgramARB;
EXTERN GlProgramStringARB glProgramStringARB;
EXTERN GlProgramEnvParameter4fvARB glProgramEnvParameter4fvARB;

EXTERN GlGenBuffersARB glGenBuffersARB;
EXTERN GlBindBufferARB glBindBufferARB;
EXTERN GlBufferDataARB glBufferDataARB;
#endif

#endif
